import { DeferredPromise } from "@codingame/monaco-vscode-api/vscode/vs/base/common/async";
import { Event } from "@codingame/monaco-vscode-api/vscode/vs/base/common/event";
import { IMarkdownString } from "@codingame/monaco-vscode-api/vscode/vs/base/common/htmlContent";
import { Disposable } from "@codingame/monaco-vscode-api/vscode/vs/base/common/lifecycle";
import { UriComponents } from "@codingame/monaco-vscode-api/vscode/vs/base/common/uri";
import { ILanguageFeaturesService } from "@codingame/monaco-vscode-api/vscode/vs/editor/common/services/languageFeatures.service";
import { ExtensionIdentifier } from "@codingame/monaco-vscode-api/vscode/vs/platform/extensions/common/extensions";
import { IInstantiationService } from "@codingame/monaco-vscode-api/vscode/vs/platform/instantiation/common/instantiation";
import { ILogService } from "@codingame/monaco-vscode-api/vscode/vs/platform/log/common/log.service";
import { IUriIdentityService } from "@codingame/monaco-vscode-api/vscode/vs/platform/uriIdentity/common/uriIdentity.service";
import { IChatWidgetService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/contrib/chat/browser/chat.service";
import { IChatAgentService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/contrib/chat/common/chatAgents.service";
import { IChatRelatedFileProviderMetadata } from "@codingame/monaco-vscode-api/vscode/vs/workbench/contrib/chat/common/chatEditingService";
import { IChatEditingService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/contrib/chat/common/chatEditingService.service";
import { IChatContentInlineReference, IChatContentReference, IChatTask, IChatTaskSerialized, IChatWarningMessage } from "@codingame/monaco-vscode-api/vscode/vs/workbench/contrib/chat/common/chatService";
import { IChatService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/contrib/chat/common/chatService.service";
import { IExtHostContext } from "../../services/extensions/common/extHostCustomers.js";
import { IExtensionService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/services/extensions/common/extensions.service";
import { Dto } from "@codingame/monaco-vscode-api/vscode/vs/workbench/services/extensions/common/proxyIdentifier";
import { IChatProgressDto, IDynamicChatAgentProps, IExtensionChatAgentMetadata, MainThreadChatAgentsShape2 } from "@codingame/monaco-vscode-api/vscode/vs/workbench/api/common/extHost.protocol";
export declare class MainThreadChatTask implements IChatTask {
    content: IMarkdownString;
    readonly kind = "progressTask";
    readonly deferred: DeferredPromise<string | void>;
    private readonly _onDidAddProgress;
    get onDidAddProgress(): Event<IChatWarningMessage | IChatContentReference>;
    readonly progress: (IChatWarningMessage | IChatContentReference)[];
    constructor(content: IMarkdownString);
    task(): Promise<string | void>;
    isSettled(): boolean;
    complete(v: string | void): void;
    add(progress: IChatWarningMessage | IChatContentReference): void;
    toJSON(): IChatTaskSerialized;
}
export declare class MainThreadChatAgents2 extends Disposable implements MainThreadChatAgentsShape2 {
    private readonly _chatAgentService;
    private readonly _chatService;
    private readonly _chatEditingService;
    private readonly _languageFeaturesService;
    private readonly _chatWidgetService;
    private readonly _instantiationService;
    private readonly _logService;
    private readonly _extensionService;
    private readonly _uriIdentityService;
    private readonly _agents;
    private readonly _agentCompletionProviders;
    private readonly _agentIdsToCompletionProviders;
    private readonly _chatParticipantDetectionProviders;
    private readonly _chatRelatedFilesProviders;
    private readonly _pendingProgress;
    private readonly _proxy;
    private readonly _activeTasks;
    private readonly _unresolvedAnchors;
    constructor(extHostContext: IExtHostContext, _chatAgentService: IChatAgentService, _chatService: IChatService, _chatEditingService: IChatEditingService, _languageFeaturesService: ILanguageFeaturesService, _chatWidgetService: IChatWidgetService, _instantiationService: IInstantiationService, _logService: ILogService, _extensionService: IExtensionService, _uriIdentityService: IUriIdentityService);
    $unregisterAgent(handle: number): void;
    $transferActiveChatSession(toWorkspace: UriComponents): void;
    $registerAgent(handle: number, extension: ExtensionIdentifier, id: string, metadata: IExtensionChatAgentMetadata, dynamicProps: IDynamicChatAgentProps | undefined): Promise<void>;
    $updateAgent(handle: number, metadataUpdate: IExtensionChatAgentMetadata): Promise<void>;
    $handleProgressChunk(requestId: string, chunks: (IChatProgressDto | [
        IChatProgressDto,
        number
    ])[]): Promise<void>;
    $handleAnchorResolve(requestId: string, handle: string, resolveAnchor: Dto<IChatContentInlineReference> | undefined): void;
    $registerAgentCompletionsProvider(handle: number, id: string, triggerCharacters: string[]): void;
    $unregisterAgentCompletionsProvider(handle: number, id: string): void;
    $registerChatParticipantDetectionProvider(handle: number): void;
    $unregisterChatParticipantDetectionProvider(handle: number): void;
    $registerRelatedFilesProvider(handle: number, metadata: IChatRelatedFileProviderMetadata): void;
    $unregisterRelatedFilesProvider(handle: number): void;
}
