import { Disposable } from "@codingame/monaco-vscode-api/vscode/vs/base/common/lifecycle";
import { UriComponents } from "@codingame/monaco-vscode-api/vscode/vs/base/common/uri";
import { IDialogService } from "@codingame/monaco-vscode-api/vscode/vs/platform/dialogs/common/dialogs.service";
import { LogLevel } from "@codingame/monaco-vscode-api/vscode/vs/platform/log/common/log";
import { IMcpRegistry } from "@codingame/monaco-vscode-api/vscode/vs/workbench/contrib/mcp/common/mcpRegistryTypes.service";
import { McpCollectionDefinition, McpConnectionState, McpServerDefinition } from "@codingame/monaco-vscode-api/vscode/vs/workbench/contrib/mcp/common/mcpTypes";
import { IAuthenticationMcpAccessService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/services/authentication/browser/authenticationMcpAccessService.service";
import { IAuthenticationMcpService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/services/authentication/browser/authenticationMcpService.service";
import { IAuthenticationMcpUsageService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/services/authentication/browser/authenticationMcpUsageService.service";
import { IAuthenticationService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/services/authentication/common/authentication.service";
import { IExtHostContext } from "../../services/extensions/common/extHostCustomers.js";
import { MainThreadMcpShape } from "@codingame/monaco-vscode-api/vscode/vs/workbench/api/common/extHost.protocol";
import { IAuthorizationProtectedResourceMetadata, IAuthorizationServerMetadata } from "@codingame/monaco-vscode-api/vscode/vs/base/common/oauth";
export declare class MainThreadMcp extends Disposable implements MainThreadMcpShape {
    private readonly _extHostContext;
    private readonly _mcpRegistry;
    private readonly dialogService;
    private readonly _authenticationService;
    private readonly authenticationMcpServersService;
    private readonly authenticationMCPServerAccessService;
    private readonly authenticationMCPServerUsageService;
    private _serverIdCounter;
    private readonly _servers;
    private readonly _serverDefinitions;
    private readonly _proxy;
    private readonly _collectionDefinitions;
    constructor(_extHostContext: IExtHostContext, _mcpRegistry: IMcpRegistry, dialogService: IDialogService, _authenticationService: IAuthenticationService, authenticationMcpServersService: IAuthenticationMcpService, authenticationMCPServerAccessService: IAuthenticationMcpAccessService, authenticationMCPServerUsageService: IAuthenticationMcpUsageService);
    $upsertMcpCollection(collection: McpCollectionDefinition.FromExtHost, serversDto: McpServerDefinition.Serialized[]): void;
    $deleteMcpCollection(collectionId: string): void;
    $onDidChangeState(id: number, update: McpConnectionState): void;
    $onDidPublishLog(id: number, level: LogLevel, log: string): void;
    $onDidReceiveMessage(id: number, message: string): void;
    $getTokenFromServerMetadata(id: number, authServerComponents: UriComponents, serverMetadata: IAuthorizationServerMetadata, resourceMetadata: IAuthorizationProtectedResourceMetadata | undefined): Promise<string | undefined>;
    private continueWithIncorrectAccountPrompt;
    private loginPrompt;
    dispose(): void;
}
